/**
*  Copyright Mikael Hgdahl - triyana@users.sourceforge.net
*
*  This source is distributed under the terms of the Q Public License version 1.0,
*  created by Trolltech (www.trolltech.com).
*/

#include <math.h>
#include <MHDouble.h>



/**
*  Rounds a number, both integer numbers and decimal numbers according to settings
*  @param double   - Number to round
*  @return double  - The rounded number
*/
double MHDouble::Round (double d) {
    int f;

    if (itsIntegerSize > 0) {
        for (f = itsIntegerSize; f > 0; f--)
            d /= 10;

        d = int(d);
        for (f = itsIntegerSize; f > 0; f--)
            d *= 10;
    }
    else if (itsFractionSize > 0) {
        for (f = itsFractionSize; f > 1; f--)
            d *= 10;

        d = int(d);
        for (f = itsFractionSize; f > 1; f--)
            d /= 10;
    }

    return d;
}



/**
*  Set fraction width.
*  @return double - Number to use for calculations of the fraction size
*/
void MHDouble::setFractionSize (double d) {
    double dd = d;
    dd = fabs (dd);
    dd = dd - int(dd);
    itsFractionSize = 0;
    while (dd <= 1.0000000 && dd > 0.000000) {
        itsFractionSize++;
        dd *= 10;
    }
}



/**
*  Set integer width
*  @param double - Number to use as a base
*/
void MHDouble::setIntegerSize (double d) {
    double  dd = fabs (d);
    itsIntegerSize = 0;

    while (dd >= 1.00000000) {
        dd /= 10;
        itsIntegerSize++;
    }
    if (d < 0)
        itsIntegerSize++;
}
