/**
*/

#ifndef MHList_h
#define MHList_h

#include <MH.h>



/**
*  Class for storing info about objects in the MHList class
*  @see MHList
*/
class MHLNode : public MH {
public:
    MH*                 itsObject;
    MHLNode*            itsNext;
    MHLNode*            itsPrev;

                        MHLNode ();
                        MHLNode (MH* o);

    static void         Swap (MHLNode* p1, MHLNode* p2);
};



/**
*  List class for storing generic objects which are inherited from MH
*/
class MHList : public MH {
public:
                        MHList ();
    virtual             ~MHList ();

    MH*                 operator() () {return (itsCurrent) ? itsCurrent->itsObject : 0;}

    const char*         Class () {return "MHList";}
    void                Empty () {empty(false);}
    void                Erase () {empty(true);}
    MH*                 Find (MH* o);
    MH*                 First() {itsCurrent = itsHead; return (itsCurrent) ? itsCurrent->itsObject : 0;}
    void                Insert (MH* o);
    MH*                 Get () {return (itsCurrent) ? itsCurrent->itsObject : 0;}
    MH*                 Last () {itsCurrent = itsTail; return (itsCurrent) ? itsCurrent->itsObject : 0;}
    MH*                 Next ();
    MH*                 Prev ();
    void                Push (MH* o);
    MH*                 Remove ();
    int                 Size () {return itsCount;}
    void                Sort (bool ascending);

protected:
    long                itsCount;
    MHLNode*            itsHead;
    MHLNode*            itsTail;
    MHLNode*            itsCurrent;

    void                empty (bool erase);
};



#endif


