/**
*  Copyright Mikael Hgdahl - triyana@users.sourceforge.net
*
*  This source is distributed under the terms of the Q Public License version 1.0,
*  created by Trolltech (www.trolltech.com).
*/

#ifndef PriceChart_h
#define PriceChart_h

#include <chart/BaseChart.h>




/**
*  Object for creating price reports and charts
*/
class PriceChart : public BaseChart {
public:
    enum CHARTS {
                            NO_CHART  = 0,
                            BAR,
                            LINE,
                            MOVING_AVERAGE,
                            ATR,
                            BOLLINGER,
                            MOMENTUM,
                            RELATIVE_,
                            RSI,
                            STDDEV,
                            STOCHASTICS,
                            VOLUME,
                            LAST_CHART,
    };

                            PriceChart (MHDC* dc, int view, MHDate::DAYS timeType);

    virtual const char*     Class () {return "PriceChart";}
    void                    Create ();
    void                    Reload (const char* message);

private:
    void                    createAtr ();
    void                    createBar ();
    void                    createBollinger ();
    void                    createLine ();
    void                    createMomentum ();
    void                    createMovingAverage ();
    void                    createRelative ();
    void                    createRSI ();
    void                    createStdDev ();
    void                    createStochastics ();
    void                    createVolume ();
};

#endif
