/**
*  Copyright Mikael Hgdahl - triyana@users.sourceforge.net
*
*  This source is distributed under the terms of the Q Public License version 1.0,
*  created by Trolltech (www.trolltech.com).
*/

#ifndef BaseDownload_h
#define BaseDownload_h

#include <MHVector.h>
#include <db/Price.h>
#include <db/Security.h>
#include <db/Set.h>
#include <db/SetItem.h>



/**
* Base object for downloading data from internet
*/
class BaseDownload : public MH {
public:
    enum TYPE {
                            HISTORY = 1,
                            LATEST
    };

    enum {
                            BUFFER_SIZE = 3000000
    };

                            BaseDownload ();
    virtual                 ~BaseDownload ();

    virtual bool            CanHistory () {return false;}
    virtual bool            CanLatest () {return false;}
    virtual const char*     Class () {return "BaseDownload";}
    void                    Close ();
    int                     HadNetworkError () {return aNetError;}
    virtual MHVector*       Load (BaseDownload::TYPE type, const char* start, const char* stop, Security* sec) = 0;

protected:
    int                     aNetError;
    char*                   aBuffer;

    const char*             getData (const char* server, const char* url);

private:
};

#endif
