/**
*  Copyright Mikael Hgdahl - triyana@users.sourceforge.net
*
*  This source is distributed under the terms of the Q Public License version 1.0,
*  created by Trolltech (www.trolltech.com).
*/

#ifndef ReportData_h
#define ReportData_h

#include <table/BaseData.h>
#include <report/Report.h>



/**
*  Supply data for reports of all kinds.
*/
class ReportData : public BaseData {
public:
                            ReportData (Report* report);
                            ~ReportData ();

    void                    add ();
    Fl_Align                align (int row, int col);
    Fl_Boxtype              box (int row, int col) {return FL_FLAT_BOX;}
    Fl_Color                boxcolor (int row, int col) {return FL_WHITE;}
    const char**            choice (int row, int col, int& size, int& selected, char* label);
    const char*             Class () {return "ReportData";}
    int                     cols() {return aReport->GetHeader()->Size();}
    FL_TABLE_EDITOR         editor_type (int row, int col, bool force_custom);
    void                    erase (int row);
    void                    insert (int row);
    const char*             header (int col);
    int                     height (int row) {return XTrader::FontSize() + 2;}
    void                    reload (const char* message);
    Report*                 report () {return aReport;}
    int                     rows() {return aReport->GetRows()->Size();}
    int                     save ();
    void                    sort (int col, bool ascending);
    Fl_Color                textcolor (int row, int col);
    bool                    value (const char* data, int row, int col);
    const char*             value (int row, int col);
    int                     width (int col);

private:
    Report*                 aReport;
};

#endif
